Subject: RE: [Speermint] Voice codecs

From: "Livingood, Jason" <[email-masked]>
Date: Fri, 28 Jul 2006 08:46:09 -0400

We ought to at least recognize that in the VoIP server & equipment
market G.711 is probably the one with widest deployment (someone will
now surely cite Skype downloads as a datapoint, I am very familiar with
it and wish someone from eBay/Skype was participating here).  In
wireless, it appears AMR is biggest (due to use by GSM), with EVRC in
second place.  This group is not going to be able to push implementation
of one codec or another (nor should we), whether we like the business
model or social model represented by that codec or not.  We do want to
figure out how to get the most people VoIP peering the fastest, and that
may (or may not) necessitate some lowest common denominator codecs.
That is far from a foregone conclusion and is a subject that will have
to be worked out by the WG over time.

This of course would not preclude use of other codecs and then endpoints
could use SIP to (normally) negotiate a different / preferred codec that
may be newer, lower bandwidth, higher fidelity, less expensive to
license, etc.

This may also be a moot point in the near future.  A recent conversation
with an endpoint maker gave me the impression that it will be pretty
easy to have all of the codecs we have mentioned here in a very low cost
endpoint in the near future.  Any hardware makers wish to comment on the
futures / possibilities?

So keep up the discussion... 

Jason 

> -----Original Message-----
> From: Klaus Darilion [mailto:[email-masked]] 
> Sent: Thursday, July 27, 2006 6:58 PM
> To: Henry Sinnreich
> Cc: [email-masked]; Greg Herlein; Ed Okerson; Lipford,Mark A [CTO]
> Subject: RE: [Speermint] Voice codecs
> 
> On Thu, July 27, 2006 22:59, Henry Sinnreich said:
> > Mark Lipford writes:
> >
> >> I am OK with SPEEX and iLBC as defaults
> >
> > Thanks and I am very happy we can come closer to an 
> agreement on this!
> >
> > Are there any other opinions on using SPEEX and iLBC (RFC 
> 3951 and RFC
> > 3952) as defaults for IP-IP broadband?
> 
> Yes. Please count the number of terminal adaptor and SIP 
> hardphones that support SPEEX and iLBC versus G.711.
> 
> regards
> klaus
> 
> 
> >
> > Thanks again, Henry
> >
> > -----Original Message-----
> > From: Lipford, Mark A [CTO] [mailto:[email-masked]]
> > Sent: Thursday, July 27, 2006 3:27 PM
> > To: Henry Sinnreich
> > Cc: Khan, Sohel Q [CTO]; [email-masked]; Greg Herlein; Francois 
> > Menard; Ed Okerson
> > Subject: RE: [Speermint] Voice codecs
> >
> > See inline
> >
> > -----Original Message-----
> > From: Henry Sinnreich [mailto:[email-masked]]
> > Sent: Thursday, July 27, 2006 3:01 PM
> > To: Lipford, Mark A [CTO]
> > Cc: Khan, Sohel Q [CTO]; [email-masked]; Greg Herlein; Francois 
> > Menard; Ed Okerson
> > Subject: RE: [Speermint] Voice codecs
> >
> > Mark Lipford writes:
> >
> >> Can we support some mechanism for support codec 
> negotiations with a 
> >> default "fall back" to G.711
> >
> > Technically, the uncompressed G.711 (1960's PCM) is definitely the 
> > worst choice for a default:
> >
> > - Narrow band telephony at 3.1 kHz audio bandwidth (why do we have 
> > BB?)
> > - Highest bandwidth consumed: Almost 90 kb/s with 
> RTP/UDP/IP overhead
> > - There are better mechanisms for Fax.
> >
> > Why do you avoid SPEEX and iLBC (RFC 3951 and RFC 3952) and 
> what are 
> > your selection criteria? Can you explain?
> > [Lipford, Mark A [NTK]] I am OK with SPEEX and iLBC as defaults, I 
> > used
> > G.711 due to 19 years in Telco :-)  The main point I was wanting to 
> > try and gain some agreement around is that narrowband (i.e. 
> 3GPP and 
> > 3GPP2 3G networks) is/are deploying IMS networks and using EVRC and 
> > AMR.  The I-D I am looking at is about Requirements for VoIP 
> > interconnection.  If this is the case it appears that support for 
> > these codecs seems to make some sense.  Again, as far as 
> SEEX and iLBC 
> > are concerned that's OK, I'm just an old telco guy.
> >
> >
> >
> > Thanks, Henry
> >
> > -----Original Message-----
> > From: Lipford, Mark A [CTO] [mailto:[email-masked]]
> > Sent: Thursday, July 27, 2006 1:46 PM
> > To: Francois Menard; Henry Sinnreich
> > Cc: Khan, Sohel Q [CTO]; [email-masked]; Greg Herlein; 
> Ed Okerson
> > Subject: RE: [Speermint] Voice codecs
> >
> > This is in response to the question to Sohel regarding Broadband.
> >
> > Yes, we are very involved in broadband, and believe 
> wireless broadband 
> > will become extremely active in the next few years, but the 
> reality is 
> > that in the 3G work both EVRC and AMR are both widely deployed and 
> > with IMS deployments starting to "spring up" around the 
> global it is 
> > probably important to also consider these needs.
> >
> > Can we support some mechanism for support codec negotiations with a 
> > default "fall back" to G.711 or some other well known default?
> >
> > I do believe that we need to also consider the narrowband 
> deployments.
> >
> > Thanks
> >
> > -----Original Message-----
> > From: Francois Menard [mailto:[email-masked]]
> > Sent: Thursday, July 27, 2006 1:41 PM
> > To: Henry Sinnreich
> > Cc: Khan, Sohel Q [CTO]; [email-masked]; Greg Herlein; 
> Ed Okerson
> > Subject: Re: [Speermint] Voice codecs
> >
> >
> > I come from Sherbrooke and you know I vote hands down for Speex
> >
> > Jean-Marc Valin prof @ U Sherbrooke has done more for the Internet 
> > than people are willing to give him credit for.
> >
> > F.
> >
> > --
> > Francois D. Menard
> > Project Manager/Charge de projet
> > Xit telecom inc.
> > 1350 Royale # 800
> > Trois-Rivieres, QC, G9A 4J4
> > Tel: +1 819 374 2556 x 268
> > Cell: +1 819 692 1383
> > [email-masked]
> >
> >
> > On Thu, 27 Jul 2006, Henry Sinnreich wrote:
> >
> >> Sohel,
> >>
> >>> A minimum set of Codecs needs to be supported that includes EvRC.
> >>
> >> How does the EvRC codec compare to the 'Internet Codecs' iLBC and
> > SPEEX?
> >>
> >> - Open source code?
> >> - Licensing fees?
> >> - Audio bandwidth?
> >> - Audio quality package?
> >> - APIs and codec abstraction for developers?
> >> - Independent lab quality assessments, etc.?
> >>
> >> More generic:
> >>
> >> How do all such closed, licensed, _narrowband voice only_ codecs
> > benefit
> >> global Internet communications and why should the IETF care?
> >>
> >> Have you heard of broadband? :-)
> >> (Note: I am a happy EVDO Sprint user).
> >>
> >> Thanks, Henry
> >>
> >> -----Original Message-----
> >> From: Khan, Sohel Q [CTO] [mailto:[email-masked]]
> >> Sent: Thursday, July 27, 2006 10:28 AM
> >> To: Jean-Francois Mule; [email-masked]
> >> Subject: [Speermint] Draft-ietf-speermint-requirements-00.txt
> >>
> >>
> >> These issues were discussed before; however, I am trying to reopen 
> >> the discussion.
> >>
> >> Section 3.3:
> >>
> >> On Codec requirements:
> >> A minimum set of Codecs needs to be supported that includes EvRC.
> >>
> >> On Editor's note:
> >> Fax, DTMF signaling, TTY/TDD, instant messaging, and 
> presence need to
> > be
> >> supported.
> >>
> >>
> >> Thank you.
> >>
> >> Sohel Khan, Ph.D.
> >> Technology Strategist
> >> Sprint-Nextel
> >> 913-794-1470 (office)
> >> 913-486-3145 (cell)
> >>
> >>
> >>
> >>
> >>
> >>
> >> _______________________________________________
> >> Speermint mailing list
> >> [email-masked]
> >> https://www1.ietf.org/mailman/listinfo/speermint
> >>
> >> _______________________________________________
> >> Speermint mailing list
> >> [email-masked]
> >> https://www1.ietf.org/mailman/listinfo/speermint
> >>
> >
> > _______________________________________________
> > Speermint mailing list
> > [email-masked]
> > https://www1.ietf.org/mailman/listinfo/speermint
> >
> >
> >
> > _______________________________________________
> > Speermint mailing list
> > [email-masked]
> > https://www1.ietf.org/mailman/listinfo/speermint
> >
> >
> >
> > _______________________________________________
> > Speermint mailing list
> > [email-masked]
> > https://www1.ietf.org/mailman/listinfo/speermint
> >
> 
> 
> 
> _______________________________________________
> Speermint mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/speermint
> 

_______________________________________________
Speermint mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/speermint

---

From: "Brian Rosen" <[email-masked]>
Date: Fri, 28 Jul 2006 09:32:43 -0400

I'm a big believer in reality.

I really like SPEEX and iLBC for the reasons Henry cites, but the reality is
that they are not widely implemented, and us writing them into a "must
implement" spec in SPEERMINT isn't going to help deployment, it will just be
another one of those "ignore here" things we sometimes do in the IETF when
religion gets in front of reality.

Perhaps what we say is this:

A Federation specifies AT LEAST ONE mandatory codec for every media stream
type (voice, video, text, ...).  Each participant must be able to send or
receive media in that codec, either by direct endpoint support or
origination side transcoding.  

Brian

> From: Livingood, Jason [mailto:[email-masked]]
> Sent: Friday, July 28, 2006 8:46 AM
> To: Klaus Darilion; Henry Sinnreich

---

From: "Geoff Devine" <[email-masked]>
Date: Fri, 28 Jul 2006 10:04:22 -0400

I agree with Brian that mandating iLBC makes no sense.  Unlike Brian, I
don't particularly "like" iLBC.  Have any of you actually done a CODEC
bake-off with iLBC in the mix?  I find the audio quality unacceptable
compared to a premium compression codec like G.729e.  You can hear iLBC
distort speech (women, in particular) and it falls over completely
reproducing music-on-hold.  It's also my opinion that iLBC steps on
quite a bit of patented IPR.  There is a significant risk of lawsuits if
a carrier deploys it.

There are always going to be cases where transcoding is necessary.  For
example, the dual-mode cell phones we have in our lab tend to only speak
the native compression codec in their ASIC.  They don't have the CPU
horsepower locally to convert it to G.711.  When you are running voice
over scarce and expensive licensed spectrum, an operator is likely to
insist on always running a compression codec native to that network
technology.

Any viable peering architecture is going to have to take transcoding
into account.  Hopefully, most peering arrangements won't need to make
much use of it.

Geoff

Geoff Devine
Chief Architect
Cedar Point Communications

-----Original Message-----
From: Brian Rosen [mailto:[email-masked]] 
Sent: Friday, July 28, 2006 9:33 AM
To: 'Livingood, Jason'; 'Klaus Darilion'; 'Henry Sinnreich'
Cc: [email-masked]; 'Greg Herlein'; 'Ed Okerson'; 'Lipford,Mark A
[CTO]'

I really like SPEEX and iLBC for the reasons Henry cites, but the
reality is
that they are not widely implemented, and us writing them into a "must
implement" spec in SPEERMINT isn't going to help deployment, it will
just be
another one of those "ignore here" things we sometimes do in the IETF
when
religion gets in front of reality.

A Federation specifies AT LEAST ONE mandatory codec for every media
stream
type (voice, video, text, ...).  Each participant must be able to send
or
receive media in that codec, either by direct endpoint support or
origination side transcoding.  

Brian

> > > Cc: Khan, Sohel Q [CTO]; [email-masked]; Greg Herlein;
Francois
> > > Cc: Khan, Sohel Q [CTO]; [email-masked]; Greg Herlein;
Francois

---

From: "Brian Rosen" <[email-masked]>
Date: Fri, 28 Jul 2006 10:12:49 -0400

I don't think arguing about iLBC will get us very far, so I'm not going to
respond to that part of your message.

I did say something in my message which may have escaped some notice.  I
said "origination side".  One of the things you have to get right on any
kind of part like transcoding is what assumptions are made.  You can assume
the origination side does it, the destination side does it or the peering
fabric itself does it.  I think it's essential to choose one, or we won't
have interoperability.  More than one is always possible, but at least one
is required.  I think origination side is best: it means that across the
peering fabric, there is at least one common codec.

Brian

> From: Geoff Devine [mailto:[email-masked]]
> Sent: Friday, July 28, 2006 10:04 AM
> To: Brian Rosen; Livingood, Jason; Klaus Darilion; Henry Sinnreich